::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 
::   CommandLine-Testbatch.bat
::
::   Version 1.0.0.1, 10.05.2011
::
::   Copyright by Rainer Ullrich, rainer@rainerullrich.de
::
::   -- Funktion --
::   Zeigt ein paar Mglichkeiten von ruSamsungTVCommunicator, gesteuert via commandline
::
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


@echo off

:: Programm
set SendProg=.\ruSamsungTVCommunicator.exe


:MyMenu
echo.
echo 1. Samsung TV auswhlen
echo 2. Eingehender Anruf, Ton aus
echo 3. SMS mit Messagetext
echo 4. SMS mit Messagedatei, Lautstrke, leise
echo 5. Termin, Lautstrke laut
echo 6. Anruf, SMS und Ton aus 
echo 7. GetMute
echo 8. GetVolume
echo 9. SetVolume
echo.
echo -E- nde
echo.
echo.
set choice=
set /p choice=Bitte Nummer eingeben und Return drcken  
if not "%choice%" == "" set choice=%choice:~0,1%
if "%choice%" == "1" goto SetTV
if "%choice%" == "2" goto call
if "%choice%" == "3" goto sms1
if "%choice%" == "4" goto sms2
if "%choice%" == "5" goto Termin
if "%choice%" == "6" goto misc
if "%choice%" == "7" goto getmute
if "%choice%" == "8" goto getvolume
if "%choice%" == "9" goto setvolume
if "%choice%" == "e" goto ende
if "%choice%" == "q" goto ende
echo.
@echo 
echo "%choice%" ist ungltig!
echo.
echo.
echo.
goto MyMenu




:SetTV
:: ---- SamsungTV setzen ----
set action=settv

:: Programmaufruf
%SendProg% -a:%action% 
:: echo ReturnCode: %errorlevel%
goto MyMenu



:call
:: ---- Eingehender Anruf, Ton aus ----
set action=call

call:DatumUhrzeit
set CalleeName=Privat
set CalleeNumber=089-123456789
set CallerName=Max Mnchner
set CallerNumber=089-87654321

:: Programmaufruf
%SendProg% -a:MuteOn -a:%action% "-cd:%Datum%" "-ca:%CalleeName%" "-cl:%CalleeNumber%" "-cc:%CallerName%" "-cn:%CallerNumber%"
:: echo ReturnCode: %errorlevel%
goto MyMenu



:sms1
:: ---- SMS mit Messagetext -----
set action=sms

call:DatumUhrzeit
set ReceiverName=%username%
set ReceiverNumber=0111-111111111
set SenderName=%computername%
set SenderNumber=0222-22222222
set Message=Ich komme heute spter heim! Servus
set MessageFile=testtext.txt

:: Programmaufruf
%SendProg% -a:%action% "-sd:%Datum%" "-sa:%ReceiverName%" "-sl:%ReceiverNumber%" "-sc:%SenderName%" "-sn:%SenderNumber%" "-sm:%Message%" 
::echo ReturnCode: %errorlevel%
goto MyMenu



:sms2
:: ---- SMS mit Text aus Datei ----
set action=sms

call:DatumUhrzeit
set ReceiverName=Pluto
set ReceiverNumber=0333-33333333
set SenderName=Micky Maus
set SenderNumber=0444-44444444
set MessageFile=testtext_%random%.txt

:: Messagefile erzeugen
echo Hallo Pluto > %MessageFile%
echo Wollen wir heute spazieren gehen? >> %MessageFile%
echo Wenn ja, dann melde Dich! >> %MessageFile%
echo Dein Micky Maus >> %MessageFile%

:: Programmaufruf
%SendProg% -a:leise -a:%action% "-sd:%Datum%" "-sa:%ReceiverName%" "-sl:%ReceiverNumber%" "-sc:%SenderName%" "-sn:%SenderNumber%" "-sf:%MessageFile%"
::echo ReturnCode: %errorlevel%

:: File lschen
del /q %MessageFile%
goto MyMenu



:Termin
:: ---- Termin, mit leise ----
set action=termin

set StartDatum=06.12.2010 18:00:00
set EndDatum=06.12.2010 22:00:00
set Terminersteller=%username%@%computername%
set TelNummer=0555-555555
set Betreff=Weihnachtsmarkt
set Ort=Marktplatz
set Message=Glhweintrinken am Weihnachtsmarkt
:: set Messagefile=

:: Programmaufruf
%SendProg% -a:laut -a:%action% "-ts:%StartDatum%" "-te:%EndDatum%" "-ta:%Terminersteller%" "-tl:%TelNummer%" "-tb:%Betreff%" "-to:%Ort%" "-tm:%Message%"
::echo ReturnCode: %errorlevel%
goto MyMenu



:misc
:: ---- Anruf, SMS und Ton aus ----
call:DatumUhrzeit

set Called=77777777
set Surname=Einstein
set Firstname=Albert
set Number=88888888
set SMStext=Eingehender Anruf von %Firstname% %Surname% mit Telefonnummer %Number% hat am %Datum% auf %Called% angerufen!

:: Programmaufruf
%SendProg% -a:MuteOn  -a:sms "-sd:%Datum%" "-sl:%Called%" "-sc:%Surname% %Firstname%" "-sn:%Number%" "-sm:%SMStext%" -a:call "-cd:%Datum%" "-cl:%Called%" "-cc:%Surname% %Firstname%" "-cn:%Number%"
:: echo ReturnCode: %errorlevel%
goto MyMenu



:getmute
:: ---- Mute auslesen ----
set action=getmute

:: Programmaufruf
%SendProg% -a:%action% 
set /a EL=%errorlevel%
:: - 0,1,2 -
:: 0 = Fehler
if %EL% EQU 0 echo    Fehler!
:: 1 = Mute off
if %EL% EQU 1 echo    Mute aus, Ton an
:: 2 = Mute on
if %EL% EQU 2 echo    Mute an, Ton aus
pause
goto MyMenu



:getvolume
:: ---- Volume auslesen ----
set action=getvolume

:: Programmaufruf
%SendProg% -a:%action% 
set /a EL=%errorlevel%
:: 0 = Fehler
if %EL% EQU 0 (
  echo    Fehler!
  pause 
  goto MyMenu
)
:: 1 abziehen, da Werte von 1 bis 101
set /a EL-=1
echo    Volume: %EL%
pause
goto MyMenu



:setvolume
:: ---- Volume setzen ----
set action=volume
echo.
echo.
echo Bitte Lautstrke eingeben, 0 bis 100
echo.
set choice=
set /p choice=Bitte Zahl eingeben und Return drcken  
:: Programmaufruf
%SendProg% -a:%action%:%choice%
set /a EL=%errorlevel%
:: 0 = Fehler
if %EL% EQU 0 (
  echo    Fehler!
  pause 
  goto MyMenu
)
echo   Neue Lautstrke: %choice%
pause 
goto MyMenu



:: ----------- SubRoutinen -----------
:DatumUhrzeit
     :: -- Datum setzen --
     set Datum=%date%_%time:~0,2%:%time:~3,2%:%time:~6,2%
     ::  Blank durch Null ersetzen, also bei 1-stelliger Stundenzahl
     set Datum=%Datum: =0%
     :: _ durch " " ersetzen
     set Datum=%Datum:_= %
goto:eof


:ende
::pause