::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 
::   ruJFritzSendToSamsungTV.bat
::
::   Version 1.0.4.0, 23.06.2011
::
::   Copyright by Rainer Ullrich, rainer@rainerullrich.de
::
::   -- Funktion --
::   Sendet eine Mitteilung und ggf. SMS bei eingehenden und/oder ausgehenden Anrufen an einen SamsungTV.
::   Auch kann der Ton an/aus/leiser/lauter gemacht werden, ebenso Fernbedienungskommandos geschickt werden.
::   Sehen Sie Anmerkung in der ruSamsungTVCommunicator-Anleitung.
::   Der Aufruf dieser Batch erfolgt ber den Anrufmonitor von JFritz.
::
::   -- Hinweis --
::   Diese ruJFritzSendToSamsungTV.bat MUSS im gleichen Verzeichnis wie die ruSamsungTVCommunicator.exe liegen!
::
::   -- Parameter --
::   1 bis 7, die von JFritz bergeben werden und die hier im Script ausgewertet werden
::   "%Called" "%Number" "%Firstname" "%Surname" "%CallType" "%Name" "%Company"
::
::
:: ------ JFritz-Variablen ------
::
:: Variablen fr den Aufruf in JFritz
::    # %Number    = Rufnummer
::    # %Name      = Vor- und Nachname mit Firma aus dem Telefonbuch
::    # %Firstname = Vorname
::    # %Surname   = Nachname
::    # %Company   = Firmenname
::    # %Called    = angerufener Anschluss 
::    # %CallType  = In, Out
::
:: Diese Batch geht davon aus, da folgender Aufruf in JFritz gemacht wird:
::    c:\Programme\JFritz\ruJFritzSendToSamsungTV.bat "%Called" "%Number" "%Firstname" "%Surname" "%CallType" "%Name" "%Company"
::
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
@echo off & setlocal enableextensions



:: ======================= hier konfigurieren - Beginn =======================

:: --- Wann soll gesendet werden ---
:: bei eingehenden Anrufen (Ja/Nein)
set SendIfIncomming=Ja

:: bei ausgehenden Anrufen (Ja/Nein)
set SendIfOutgoing=Nein

:: --- Was soll gesendet werden ---
:: Anruf anzeigen am TV    (Ja/Nein)
set ViewCall=Ja

:: SMS an TV senden        (Ja/Nein)
set SendSMS=Ja

:: Volume  am TV ndern    (MuteOn/MuteOff/leise/normal/-)
set Volume=leise

:: Fernbedienungskommandos (gltige Keys oder selbst definierte Makros/-) Siehe Anleitung von ruSamsungTVCommunicator.
::   Zum Beispiel: 
::       $$GoTV   = Beendet z.B. MediaPlayer und geht zum TV zurck
::       $$GoTV2  = Beendet z.B. MediaPlayer durch mehrere "Exits" und geht zum TV zurck
::       $voldown = macht die Lautstrke eins leiser
set RCCommands=-

:: Programm-Optionen       (siehe Anleitung/-)
::   Zum Beispiel: 
::       -x:silent = keine TrayTip-Ausgabe unten rechts -> ruSamsungTVCommunicator arbeitet laut- und meldungslos
set ProgOptions=-

:: ======================= hier konfigurieren - Ende =======================



:: Work-Pfad (mit "\" am Ende!)
set WorkPath=%~d0%~p0
:: "\" abschneiden
set WorkPath=%WorkPath:~0,-1%
:: ins Verzeichnis wechseln
cd /d %WorkPath%

:: Pfad fr die Logfiles
set LogPath=%WorkPath%\Debug-Logs



:: bergabe-Parameter in sprechende Variablen umbenennen und Anfhrungszeichen entfernen
::  "%Called" "%Number" "%Firstname" "%Surname" "%CallType" "%Name" "%Company"
set Called=%~1
set Number=%~2
set Firstname=%~3
set Surname=%~4
set CallType=%~5
set NameAndMore=%~6
set Company=%~7

:: Programm-Pfad
set SendToSamsungTVProg=%WorkPath%\ruSamsungTVCommunicator.exe

:: Logfile setzen
set LogFile=%LogPath%\ruJFritzSendToSamsungTV-LogFile.txt

:: Random-Zahl
set MyRandom=%random%

:: HilfsVars
set DoSend=0

:: ---- SMS-Inhalt zusammenbauen ----
rem Datum und Uhrzeit ermitteln
set yyyymmddhhmmss=%date:~6,4%%date:~3,2%%date:~0,2%_%time:~0,2%%time:~3,2%%time:~6,2%
rem Blank durch Null ersetzen, also bei 1-stelliger Stundenzahl
set yyyymmddhhmmss=%yyyymmddhhmmss: =0%
set SMSContentFile=%tmp%\JFritz-SMS_%yyyymmddhhmmss%_%MyRandom%.txt

:Eingehend
:: - Eingehender Anruf -
if "%CallType%" NEQ "In" goto Ausgehend
if "%SendIfIncomming%" NEQ "Ja" goto Ausgehend
:: Betreff
set Betreff=Eingehender Anruf auf %Called% von %Surname%, %Firstname% (%Number%) am %date% um %time%
:: SMS-Inhalt
:: Codec umstellen
chcp 1252 >nul 2>&1
echo Eingehender Anruf > %SMSContentFile%
echo von %Surname%, %Firstname% (Firma: %Company%) >> %SMSContentFile%
echo mit Nummer %Number% >> %SMSContentFile%
echo auf %Called% >> %SMSContentFile%
echo am %date% um %time% >> %SMSContentFile%
chcp 850 >nul 2>&1
set DoSend=1
goto SetOptionen


:Ausgehend
:: - Abgehender Anruf -
if "%CallType%" NEQ "Out" goto SetOptionen
if "%SendIfOutgoing%" NEQ "Ja" goto SetOptionen
:: Betreff
set Betreff=Ausgehender Anruf auf %Called% von %Surname%, %Firstname% (%Number%) am %date% um %time%
:: SMS-Inhalt
:: Codec umstellen
chcp 1252 >nul 2>&1
echo Ausgehender Anruf > %SMSContentFile%
echo an %Surname%, %Firstname% (Firma: %Company%) >> %SMSContentFile%
echo auf Nummer %Number% >> %SMSContentFile%
echo mit %Called% >> %SMSContentFile%
echo am %date% um %time% >> %SMSContentFile%
chcp 850 >nul 2>&1
set DoSend=1
goto SetOptionen


:SetOptionen
if %DoSend% EQU 0 goto StartLogFile
set options=

:: - Datum/Uhrzeit -
call:DatumUhrzeit

:SetProgOptions
:: - Program-Optionen -
set ProgOptions=%ProgOptions: =%
if "%ProgOptions%" EQU "-" goto SetRC
if "%ProgOptions%" NEQ "" set options=%options% -a:rc:%ProgOptions% 

:SetRC
:: - Fernbedienung -
set RCCommands=%RCCommands: =%
if "%RCCommands%" EQU "-" goto SetVol
if "%RCCommands%" NEQ "" set options=%options% -a:rc:%RCCommands% 

:SetVol
:: - Volume -
:: Blank entfernen
set Volume=%Volume: =%
if "%Volume%" EQU "-" goto SetSMS
if "%Volume%" NEQ "" set options=%options% -a:%volume%

:SetSMS
:: - SMS -
:: Blank entfernen
set SendSMS=%SendSMS: =%
if "%SendSMS%" EQU "Ja" set options=%options% -a:sms "-sd:%DatumUhrzeit%" "-sl:%Called%" "-sc:%Surname% %Firstname%" "-sn:%Number%" "-sf:%SMSContentFile%"

:: - Call -
:: Blank entfernen
set ViewCall=%ViewCall: =%
if "%ViewCall%" EQU "Ja" set options=%options% -a:call "-cd:%DatumUhrzeit%" "-cl:%Called%" "-cc:%Surname% %Firstname%" "-cn:%Number%"

:StartLogFile
:: ---- LogFile befllen ----
echo. >> %LogFile%
echo ---------------------------------------------------------------------------------------- >> %LogFile%
echo Aufruf Nr. %MyRandom% >> %LogFile%
echo Verzeichnis ist %cd% >> %LogFile%
echo Anruf um %date% %time% >> %LogFile%
echo Argument 1: %1 >> %LogFile%
echo Argument 2: %2 >> %LogFile%
echo Argument 3: %3 >> %LogFile%
echo Argument 4: %4 >> %LogFile%
echo Argument 5: %5 >> %LogFile%
echo Argument 6: %6 >> %LogFile%
echo Argument 7: %7 >> %LogFile%
echo Argument 8: %8 >> %LogFile%
echo Argument 9: %9 >> %LogFile%
echo. >> %LogFile%
if %DoSend% EQU 0 (
   echo kein Senden einer Message! >> %LogFile%
   echo. >> %LogFile%
   goto Ende
) else (
   echo SendToTV-Optionen: %options% >> %LogFile%
   echo. >> %LogFile%
)


:ViewOnSamsungTV
set KopieOptionen=%options%NIX
:: remove quotes for compare
set "KopieOptionen=%KopieOptionen:"=%"
if "%KopieOptionen%" EQU "NIX" goto ENDE

:: -- Datum setzen --
set DatumUhrzeit=%date%_%time:~0,2%:%time:~3,2%:%time:~6,2%
::  Blank durch Null ersetzen, also bei 1-stelliger Stundenzahl
set DatumUhrzeit=%DatumUhrzeit: =0%
:: _ durch " " ersetzen
set DatumUhrzeit=%DatumUhrzeit:_= %

:: --- Talk to SamsungTV --
echo SendToTV Start %MyRandom% um %date% %time% >> %LogFile%
start "test" %SendToSamsungTVProg% %options%
:: Errorlevel gibt es nicht bei "start"
:: set EL=%errorlevel%
:: echo SendToTV - Ergebnis: %EL% >> %LogFile%
echo SendToTV Ende  %MyRandom% um %date% %time% >> %LogFile%
echo. >> %LogFile%
goto Ende


:Ende
:: SMS-Inhalt-File lschen -> da mit "start" gestartet wird, besser nicht
:: if exist %SMSContentFile% del /q %SMSContentFile%

echo Anruf-Ende %MyRandom% um %date% %time% >> %LogFile%
endlocal & goto :EOF




:: ----------- SubRoutinen -----------
:DatumUhrzeit
     :: -- Datum setzen --
     set Datum=%date%_%time:~0,2%:%time:~3,2%:%time:~6,2%
     ::  Blank durch Null ersetzen, also bei 1-stelliger Stundenzahl
     set Datum=%Datum: =0%
     :: _ durch " " ersetzen
     set Datum=%Datum:_= %
goto:eof
